/**
* La classe ArduinoParsor s'occupe d'injecter les données dans le système à partir du vecteur de bit envoyé par la carte.
* @version 	1.0, 06/04/2011
* @author	Thibaud Michel & Flavien Garcia
*/

package Controler.Parsor;

import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;
import gnu.io.SerialPortEvent;
import gnu.io.SerialPortEventListener;

import java.awt.geom.Point2D;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

public class ArduinoParsor implements SerialPortEventListener {
	SerialPort serialPort;
        /** The port we're normally going to use. */
	private static final String PORT_NAMES[] = { 
			"/dev/tty.usbserial-A9007UX1", // Mac OS X
			"/dev/ttyUSB0", // Linux
			"COM8", // Windows
			};
	/** Buffered input stream from the port */
	private InputStream input;
	/** The output stream to the port */
	//private OutputStream output;
	/** Milliseconds to block while waiting for port open */
	private static final int TIME_OUT = 2000;
	/** Default bits per second for COM port. */
	private static final int DATA_RATE = 9600;
	
	/** Buffer des bits de sortie */
	private String tempBuffer = "";
	
	List<ParsorListener> parsorListenerList;

	public void initialize() {
		CommPortIdentifier portId = null;
		Enumeration<?> portEnum = CommPortIdentifier.getPortIdentifiers();

		// iterate through, looking for the port
		while (portEnum.hasMoreElements()) {
			CommPortIdentifier currPortId = (CommPortIdentifier) portEnum.nextElement();
			for (String portName : PORT_NAMES) {
				if (currPortId.getName().equals(portName)) {
					portId = currPortId;
					break;
				}
			}
		}

		if (portId == null) {
			System.out.println("Arduino parsor non démarré");
			return;
		}
		
		System.out.println("Arduino parsor démarré");
		

		try {
			// open serial port, and use class name for the appName.
			serialPort = (SerialPort) portId.open(this.getClass().getName(),
					TIME_OUT);

			// set port parameters
			
			serialPort.setSerialPortParams(DATA_RATE,
					SerialPort.DATABITS_8,
					SerialPort.STOPBITS_1,
					SerialPort.PARITY_NONE);

			// open the streams
			input = serialPort.getInputStream();
			//output = serialPort.getOutputStream();

			// add event listeners
			serialPort.addEventListener(this);
			serialPort.notifyOnDataAvailable(true);
		} catch (Exception e) {
			System.err.println(e.toString());
		}
	}

	/**
	 * This should be called when you stop using the port.
	 * This will prevent port locking on platforms like Linux.
	 */
	public synchronized void close() {
		if (serialPort != null) {
			serialPort.removeEventListener();
			serialPort.close();
		}
	}

	/**
	 * Handle an event on the serial port. Read the data and print it.
	 */
	public synchronized void serialEvent(SerialPortEvent oEvent) {
		if (oEvent.getEventType() == SerialPortEvent.DATA_AVAILABLE) {
			try {
				int available = input.available();
				byte chunk[] = new byte[available];
				input.read(chunk, 0, available);
				// Displayed results are codepage dependent
				for(int i=0;i<available;i++) {
					if(chunk[i] == 13) {}
					else if(chunk[i] == 10) {
						parse(tempBuffer);
						tempBuffer = "";
					}
					else
						tempBuffer += (char)chunk[i];
				}
			} catch (Exception e) {
				System.err.println(e.toString());
			}
		}
		// Ignore all the other eventTypes, but you should consider the other ones.
	}
	
	/**
	 * Parse le vecteur de bits et l'injecte dans le SensorFactory
	 * @param str vecteur de bits
	 */
	private void parse(String str){		
		String[] sp = str.split("-");
		
		if(sp.length == 2) {
			
			Point2D.Double point = new Point2D.Double();
			point.x = Integer.parseInt(sp[0]);
			point.y = Integer.parseInt(sp[1]);
			
			for(ParsorListener pl : parsorListenerList) {
				pl.parsorCoordinates(point, 50);
			}
			
		}
	}

	/**
	 * Constructeur
	 * @param sf la SensorsFactory
	 * @param main la Jframe principale
	 */
	public ArduinoParsor() {
		parsorListenerList = new ArrayList<ParsorListener>();
		initialize();
	}
	
	
	public void subscribe(ParsorListener pl) {
		parsorListenerList.add(pl);
	}
	
	public void unsubscribe(ParsorListener pl) {
		parsorListenerList.remove(pl);
	}
	
}